#!/usr/bin/perl -w
# wmmTk.pl - who mailed me Konfigurationstool
# Version 1.2, letzte nderung 19.11.97, 15:10 Uhr

# Vordeklarierung der Variablen
use vars qw(
  $wmm_NamePrio $wmm_listListe $wmm_listScroll 
  $wmm_main $CODE $FILTER $NAME $wmm_AdrEntry $wmm_SendEntry 
  $wmm_filterEntry1 $wmm_filterEntry2 $wmm_filterEntry3 
  $wmm_filterEntry4);

# dann noch strikte Pruefung
use strict;
use Tk;       # perlTk fuer die Oberflaeche
use IniConf;  # Zum einlesen der Konfigurationsdatei

###
#
# Hauptfenster und komplette Oberflaeche erzeugen
#
###

$wmm_main = new MainWindow(-title => 'wmmTk - WhoMailedMe Konfigurationstool 1.2');


# 0. Frame
my $wmm_frame0 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame0->pack(-fill => 'x');

# Text/Zahlen
my $wmm_CodLabel  = $wmm_frame0->Label(-text => 'Kodierung:');
$wmm_CodLabel->pack(-side => 'left',-fill => 'x');

my $wmm_frame01 = $wmm_frame0->Frame->pack;
my $wmm_textButton = $wmm_frame01->Radiobutton(-text => 'Text',-variable => \$CODE,-value => 'TEXT');
$wmm_textButton->pack(-side => 'left', -fill => 'x');
my $wmm_scodeButton = $wmm_frame01->Radiobutton(-text => 'SCODE',-variable => \$CODE,-value => 'SCODE');
$wmm_scodeButton->pack(-side => 'right', -fill => 'x');
$wmm_textButton->select;

# 1. Frame
my $wmm_frame1 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame1->pack(-fill => 'x');

# Pager/Handy - Adressen Label
my $wmm_AdrLabel  = $wmm_frame1->Label(-text => 'Pager/Handy Adresse:');
$wmm_AdrLabel->pack(-side => 'left',-fill => 'x');

# Pager/Handy - Adresen Eingabefeld
$wmm_AdrEntry = $wmm_frame1->Entry(-width => 30)->pack(-side => 'right',-fill => 'x');


# 2. Frame
my $wmm_frame2 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame2->pack(-fill => 'x');

# SMTP-Server Adressen Label
my $wmm_ServLabel = $wmm_frame2->Label(-text => 'SMTP-Server:');
$wmm_ServLabel->pack(-side => 'left', fill => 'x');

# SMTP-Server Adressen Eingabefeld
my $wmm_ServEntry = $wmm_frame2->Entry(-width => 30)->pack(-side => 'right',-fill => 'x');


# 3.Frame 
my $wmm_frame3 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame3->pack(-fill => 'x');

# Maximale Anzahl zu uebertragender Zeichen Label
my $wmm_lenLabel = $wmm_frame3->Label(-text => 'Anzahl Zeichen:');
$wmm_lenLabel->pack(-side => 'left', fill => 'x');

# Maximale Anzahl zu uebertragender Zeichen Eingabefeld
my $wmm_lenEntry = $wmm_frame3->Entry(-width => 30)->pack(-side => 'right',-fill => 'x');

# 4. Frame
my $wmm_frame4 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);

$wmm_frame4->pack(-fill => 'x');

# Absender Adressen Label
my $wmm_SendLabel = $wmm_frame4->Label(-text => 'Absender Adresse:');
$wmm_SendLabel->pack(-side => 'left', fill => 'x');

# Absender Adressen Eingabefeld
$wmm_SendEntry = $wmm_frame4->Entry(-width => 30)->pack(-side => 'right',-fill => 'x');

# 5. Frame
my $wmm_frame5 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame5->pack(-fill => 'x');

my $wmm_filterFrame1 = $wmm_frame5->Frame->pack(-fill => 'x');
$wmm_filterFrame1->Label(-text => 'EMails filter ber...')->pack(-side => 'left', -fill => 'x');

my $wmm_filterFrame2  = $wmm_frame5->Frame->pack(-fill => 'x');
my $wmm_filterButton1 = $wmm_filterFrame2->Radiobutton(-state => 'normal',
                                                       -text => 'POP3-Server',
													   -variable => \$FILTER,
													   -value => 'POP3');
$wmm_filterButton1->pack(-side =>'left',-fill => 'x');


my $wmm_filterFrame3 = $wmm_frame5->Frame->pack(-fill => 'x');
my $wmm_filterFrame31 = $wmm_filterFrame3->Frame->pack(-side => 'left', -fill => 'x');
my $wmm_filterLabel1 = $wmm_filterFrame31->Label(-text => 'Server Adresse:');
$wmm_filterLabel1->pack(-padx => '5m', -side => 'left', -fill => 'x');
my $wmm_filterFrame32 = $wmm_filterFrame3->Frame->pack(-side => 'right');
$wmm_filterEntry1  = $wmm_filterFrame31->Entry(-state => 'normal',-width => 30);
$wmm_filterEntry1->pack(-side => 'right', -fill =>'x');

my $wmm_filterFrame4 = $wmm_frame5->Frame->pack(-fill => 'x');
my $wmm_filterFrame41 = $wmm_filterFrame4->Frame->pack(-side => 'left', -fill => 'x');
my $wmm_filterLabel2 = $wmm_filterFrame41->Label(-text => 'Benutzername:  ');
$wmm_filterLabel2->pack(-padx => '5m', -side => 'left', -fill => 'x');
my $wmm_filterFrame42 = $wmm_filterFrame4->Frame->pack(-side => 'right', -fill => 'x');
$wmm_filterEntry2 = $wmm_filterFrame41->Entry(-state => 'normal',-width => 30);
$wmm_filterEntry2->pack(-side => 'right', -fill =>'x');

my $wmm_filterFrame5 = $wmm_frame5->Frame->pack(-fill => 'x');
my $wmm_filterFrame51 = $wmm_filterFrame5->Frame->pack(-side => 'left', -fill => 'x');
my $wmm_filterLabel3 = $wmm_filterFrame51->Label(-text => 'Pawort:              ')->pack(-padx => '5m', -side => 'left', -fill => 'x');
my $wmm_filterFrame52 = $wmm_filterFrame5->Frame->pack(-side => 'right');
$wmm_filterEntry3  = $wmm_filterFrame51->Entry(-show => '*',-state => 'normal',-width => 30)->pack(-side => 'right', -fill =>'x');

my $wmm_filterFrame6  = $wmm_frame5->Frame->pack(-fill => 'x');
my $wmm_filterButton2 = $wmm_filterFrame6->Radiobutton(-text => 'Mailspooler-Datei',-variable => \$FILTER, -value => 'Mail')->pack(-side => 'left');
$wmm_filterEntry4  = $wmm_filterFrame6->Entry(-width => 30)->pack(-side => 'right');

# 6. Frame
my $wmm_frame6 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame6->pack(-fill => 'x');

# Prioritaeten Label
my $wmm_PrioLabel = $wmm_frame6->Label(-text => 'bermittlung:')->pack(-side => 'left');
my $wmm_PrioFrame = $wmm_frame6->Frame(-relief => 'sunken')->pack(side => 'right', -fill => 'x');

$wmm_NamePrio  = $wmm_PrioFrame->Radiobutton(-text => 'nur Namen',-variable => \$NAME,-value => '[NN]');
$wmm_NamePrio->pack(-side => 'left', -fill => 'x');

my $wmm_SubjPrio  = $wmm_PrioFrame->Radiobutton(-text => 'Namen + Betreff',-variable => \$NAME, -value => '[NB]');
$wmm_SubjPrio->pack(-side => 'right', -fill => 'x');

# 7. Frame
my $wmm_frame7 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame7->pack(-fill => 'x');

my $wmm_AliasLabel = $wmm_frame7->Label(-text => 'Nickname/Alias:')->pack(-side => 'left');
my $wmm_AliasEntry = $wmm_frame7->Entry(-width => 30)->pack(-side => 'right');

# 8. Frame
my $wmm_frame8 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 50);
$wmm_frame8->pack(-fill => 'x');
my $wmm_NameLabel = $wmm_frame8->Label(-text => 'EMail Adresse:')->pack(-side => 'left');
my $wmm_NameEntry = $wmm_frame8->Entry(-width => 30)->pack(-side => 'right');

# 9. Frame
my $wmm_frame9 = $wmm_main->Frame(-relief => 'ridge',
                                  -width => 640,
                                  -height => 100);
$wmm_frame9->pack(-fill => 'x');

my $wmm_ButtonFrame = $wmm_frame9->Frame->pack(-side =>'right', -fill => 'x');
my $wmm_savButton = $wmm_ButtonFrame->Button(-text => 'Speichern');

$wmm_savButton->configure(-command => sub{write_ini($wmm_AdrEntry,$wmm_ServEntry,$wmm_lenEntry,
                                                    $wmm_SendEntry,$wmm_AliasEntry,$wmm_NameEntry)});
$wmm_savButton->pack(-fill => 'x');

my $wmm_delButton = $wmm_ButtonFrame->Button(-text => 'Lschen', 
                                             -command => sub{delete_list_item($wmm_listListe)});

$wmm_delButton->pack(-fill => 'x');

my $wmm_modButton = $wmm_ButtonFrame->Button(-text => 'ndern', 
                                             -command => sub{modify_list_item($wmm_listListe,
											                                  $wmm_AliasEntry,
																			  $wmm_NameEntry)});
$wmm_modButton->pack(-fill => 'x');

my $wmm_InsButton = $wmm_ButtonFrame->Button(-text => 'Hinzufgen', 
                                             -command => sub{insert_ini($wmm_listListe,$wmm_AliasEntry,$wmm_NameEntry)})->pack(-fill => 'x');
my $wmm_ExiButton = $wmm_ButtonFrame->Button(-text => 'Quit', -command => sub{exit})->pack(-fill => 'x');

my $wmm_listFrame   = $wmm_frame9->Frame->pack(-side =>'left', -fill => 'x');
my $wmm_listLabel   = $wmm_frame9->Label(-text => 'Positivliste:')->pack(-side => 'top', -fill => 'x');
$wmm_listListe   = $wmm_frame9->Listbox(-setgrid => 'yes',-selectmode => 'single');
$wmm_listScroll = $wmm_frame9->Scrollbar(-command => ['yview', $wmm_listListe])->pack(-side => 'right', -fill => 'y');
$wmm_listListe->configure(-yscrollcommand => ['set', $wmm_listScroll]);
$wmm_listListe->bind('<Double-1>', => sub{display_list_item($wmm_listListe)},);
$wmm_listListe->pack(-fill => 'both');

&read_ini; # Wenn es schon eine WMM.ini Datei gibt, lese sie ein.

MainLoop;  # Die Ereignisschleife

###
#
# Unterprogramme 
#
###

# modify_list_item
# Aendern eines Listeneintrags
sub modify_list_item {
  my ($list,$alias,$name) = @_;
  my $nick  = $alias->get;
  my $email = $name->get;
  my @liste = $wmm_listListe->get('0','end');  
  my @row = ();
  my $found = 'false';
  my $msgmode = $NAME;
  my $index = 0;
  my $item = '';

  if(($nick ne '') && ($email ne '')) {

	foreach $item (@liste) {
	  @row = split ' ', $item;
	  if(($row[0] eq $nick) || ($row[2] eq $email)) {
	    $found = 'true';
	    last;
	  }
	  $index++;
	}

	if($found eq 'true') {
	  $wmm_listListe->delete($index);  
	  $wmm_listListe->insert($index, $nick." fr ".$email." ".$NAME);  
	}
  }
}

# display_list_item zeigt einen Listeneintrag der mit 
# einem Doppelklick ausgewaehlt wurde
sub display_list_item {
  my ($liste) = @_;
  my $item = $liste->get('active');
  my @row = split ' ',$item;
 
  $wmm_NameEntry->delete('0','end');
  $wmm_NameEntry->insert('end',$row[2]);
  $wmm_AliasEntry->delete('0','end');
  $wmm_AliasEntry->insert('end',$row[0]);
  if($row[3] eq '[NN]') {
    $wmm_NamePrio->select;
  }
  elsif ($row[3] eq '[NB]') {
    $wmm_SubjPrio->select;
  } 
}

# delete_list_item
# Loeschen eines Listeintrags
sub delete_list_item {
  my ($liste) = @_;
  my $item = $liste->get('active');
  my @row = split ' ',$item;

  # Eintrag wirklich loeschen?
  my $wmm_dialog = $wmm_main->Toplevel(-title => 'wmmTk: Namen lschen');
  my $wmm_frame1 = $wmm_dialog->Frame(-relief => 'flat',
                                      -width => 200,
									  -height => 200)->pack(-fill => 'x');
  my $msg = 'Mchten Sie '.$row[0].' wirklich aus Ihrer Liste lschen.';

  $wmm_frame1->Label(-bitmap => 'question')->pack(-side => 'left', -padx => '2m', -pady => '5m');
  $wmm_frame1->Label(-text => $msg)->pack(-side => 'right');

  my $wmm_frame2 = $wmm_dialog->Frame(-relief => 'flat',
									  -width => 200,
  									  -height => 200)->pack(-fill => 'x');
  $wmm_frame2->Button(-text => 'Lschen', -command => sub{$wmm_listListe->delete('active');
                                                      &write_ini($wmm_AdrEntry,$wmm_ServEntry,$wmm_lenEntry,
                                                                 $wmm_SendEntry,$wmm_AliasEntry,$wmm_NameEntry);
													  destroy $wmm_dialog})->pack(-side => 'left');
  $wmm_frame2->Button(-text => '   Nein   ',-command => sub{destroy $wmm_dialog})->pack(-side => 'right');
}

# read_ini
# wmm.ini Datei einlesen
sub read_ini {
	my $wmm_ini = undef;
	my $adr = '';
	my $serv = '';
	my $len = 0;
	my $code = '';
	my $sender = '';
	my $mailm = '';
	my $spool = '';
	my $pop = '';
	my @pop3row = ();
    my $no_of_names = 0;
    my $index = 0;
    my @liste = ();

	$wmm_ini = IniConf->new(-file => "wmm.ini" );

	if($wmm_ini) {
		$adr = $wmm_ini->val('EINSTELLUNGEN', 'PagerAdress');
		$wmm_AdrEntry->insert('end',$adr);
		$serv = $wmm_ini->val('EINSTELLUNGEN', 'SMTPServer');
		$wmm_ServEntry->insert('end',$serv);
		$len = $wmm_ini->val('EINSTELLUNGEN', 'MessageLen');
		$wmm_lenEntry->insert('end',$len);
		$code = $wmm_ini->val('EINSTELLUNGEN', 'Code');
		if($code eq 'TEXT') {
		  $wmm_textButton->select;
		}
		elsif($code eq 'SCODE') {
		  $wmm_scodeButton->select;
		}

        $sender = $wmm_ini->val('EINSTELLUNGEN', 'SenderAccount');
		$wmm_SendEntry->insert('end',$sender);
        $mailm = $wmm_ini->val('EINSTELLUNGEN', 'GetMethode');

		if($mailm eq 'POP3') {
		  $wmm_filterButton1->select;
		  $pop = $wmm_ini->val('EINSTELLUNGEN', 'POP3Server');
		  @pop3row = split ' ',$pop;
		  $wmm_filterEntry1->insert('end',$pop3row[0]);
		  $wmm_filterEntry2->insert('end',$pop3row[1]);
		  $wmm_filterEntry3->insert('end',$pop3row[2]);
		}
		elsif($mailm eq 'Mail') {
		  $wmm_filterButton2->select;
		  $spool = $wmm_ini->val('EINSTELLUNGEN', 'MailBox');
		  $wmm_filterEntry4->insert('end',$spool);
		}  
		
		$no_of_names = $wmm_ini->val('NAMEN','Anzahl');
		for($index = 1; $index <= $no_of_names; $index++) {
		  $liste[$index] = $wmm_ini->val('NAMEN','Name'.$index);
		  $wmm_listListe->insert('end',$liste[$index]);  
		}

	}
	else {
    print "wmmTk: leider keine INI-Datei gefunden!\n";
  }

	
}

# insert_ini fuegt einen neuen Namen in die Liste ein und 
# ueberprueft ob er nicht schon enthalten ist
sub insert_ini {
  my ($list,$alias,$name) = @_;
  my $nick  = $alias->get;
  my $email = $name->get;
  my @liste = $wmm_listListe->get('0','end');  
  my @row = ();
  my $found = 'false';
  my $msgmode = $NAME;
  my $item = '';

  if(($nick ne '') && ($email ne '')) {

	foreach $item (@liste) {
	  @row = split ' ', $item;
	  if($row[0] eq $nick) {
	    $found = 'true';
	    last;
	  }
	}

	if($found eq 'false') {
	  $wmm_listListe->insert('end', $nick." fr ".$email." ".$NAME);  
	}
	else {
	  # Fehler Dialog erzeugen
	  my $wmm_dialog = $wmm_main->Toplevel(-title => 'wmmTk: Fehler');
	  my $wmm_frame1 = $wmm_dialog->Frame(-relief => 'flat',
	                                      -width => 200,
										  -height => 200)->pack(-fill => 'x');
	  my $msg = 'Der Alias '.$nick.' ist schon in Ihrer Liste enthalten.';

	  $wmm_frame1->Label(-bitmap => 'warning')->pack(-side => 'left', -padx => '2m', -pady => '5m');
      $wmm_frame1->Label(-text => $msg)->pack(-side => 'right');

	  my $wmm_frame2 = $wmm_dialog->Frame(-relief => 'flat',
										  -width => 200,
	  									  -height => 200)->pack(-fill => 'x');
	  $wmm_frame2->Button(-text => 'Weiter', -command => sub{destroy $wmm_dialog})->pack;
	}
  }
}

# write_ini 
# Schreibt die wmm.ini Datei 
sub write_ini {
  my ($adr,$serv,$len,$send,$alias,$name) = @_;
  my $filename = 'wmm.ini';
  my @liste = $wmm_listListe->get('0','end'); # alle Listeneintraege
  my $index = 0;
  
  # Neue wmm.ini Datei erzeugen
  open (WMMFILE,">$filename") || die "WMM: Konnte keine INI-Datei $filename anlegen!\n";
  print WMMFILE "[EINSTELLUNGEN]\n";
  print WMMFILE "PagerAdress=",$adr->get,"\n";
  print WMMFILE "SMTPServer=",$serv->get,"\n";

  if($CODE eq 'TEXT') {
	print WMMFILE "Code=TEXT\n";
  }
  else {
    print WMMFILE "Code=SCODE\n";
  }

  print WMMFILE "MessageLen=",$len->get,"\n";
  print WMMFILE "SenderAccount=",$send->get,"\n";
  
  # Mit welcher Methode sollen die EMails gefiltert werden
  # ueber einen POP3-Server
  if($FILTER eq 'POP3') {
    print WMMFILE "GetMethode=",$FILTER,"\n";
	print WMMFILE "POP3Server=",$wmm_filterEntry1->get," ",$wmm_filterEntry2->get," ",$wmm_filterEntry3->get,"\n";
  }
  # oder eine lokale Mailspooler-Datei
  elsif ($FILTER eq 'Mail') {
    print WMMFILE "GetMethode=",$FILTER,"\n";
	print WMMFILE "MailBox=",$wmm_filterEntry4->get,"\n";  
  }

  print WMMFILE "\n";

  # Alle Namen die in der Lisbox aufgefuehrt sind speichern
  print WMMFILE "[NAMEN]\n";
  print WMMFILE "Anzahl=",scalar @liste,"\n";
  foreach (@liste) {
    $index++;
    print WMMFILE "Name",$index,"=",$_,"\n";
  }
  print WMMFILE "\n";
  close(WMMFILE);
}